var bkg = chrome.extension.getBackgroundPage();
var authtokenFetched = false;
var videosFetched = false;
// bkg.console.log('hello world');

chrome.storage.local.get(["vooAPIKey"], function (items) {
    if (items.vooAPIKey) {
        getVideos(items.vooAPIKey);
        chrome.storage.local.set({'betaOptimization': 'true'}, function () {
        });
        chrome.storage.local.set({'fallbackCode': 'false'}, function () {
        });
    } else {
        logout();
    }
});

function logout() {
    chrome.storage.local.remove(["vooAPIKey"], function () {
    })
    document.getElementById('mainMenu').style.display = "none";
    document.getElementById('loginForm').style.display = "block";
    document.getElementById('loginHeader').style.display = "block";
}

document.getElementById('vooLogoutBtn').onclick = function () {
    logout();
}

function getAPIKey(user) {
    const authRequest = new XMLHttpRequest();
    const token = user.token;
    const userId = user.id;

    authRequest.open("GET", 'https://api.vooplayer.com/user/generateIntegrationsApiKey?Token=' + token + '&userID=' + userId);
    authRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    authRequest.onreadystatechange = function () {
        if (authRequest && authRequest.responseText) {
            var apiKey = JSON.parse(authRequest.responseText);

            chrome.storage.local.set({
                "vooAPIKey": apiKey,
                'subdomain': user.subdomain,
                'betaOptimization': 'true'
            }, function () {
            });

            if (!videosFetched) {
                getVideos(apiKey);
                videosFetched = true;
            }
        }
    };

    authRequest.send();
}

function loginHandle(username, password) {
    const authRequest = new XMLHttpRequest();

    authRequest.open("POST", 'https://api.vooplayer.com/login');
    authRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    authRequest.send('username=' + username + '&password=' + password);
    authRequest.onreadystatechange = function (e) {
        if (authRequest && authRequest.responseText) {
            var authData = JSON.parse(authRequest.responseText);
            var user = authData[0];

            if (user.integrationsApiKey) {
                if (authRequest.readyState === 4 && authRequest.status === 200) {
                    _gaq.push(['_trackEvent', 'Extension Login', 'Successful']);
                    chrome.storage.local.set({
                        "vooAPIKey": user.integrationsApiKey,
                        'subdomain': user.subdomain,
                        'betaOptimization': 'true'
                    }, function () {
                    });
                    getVideos(user.integrationsApiKey);
                }
            } else {
                /*if (!user.token && !authtokenFetched) {
                    loginHandle(username, password);

                    return;
                }*/
                if (user.id && !authtokenFetched) {
                    authtokenFetched = true;
                    // Create API token.
                    getAPIKey(user);
                } else if (!user.id) {
                    alert('Bad Credentials or no API key found.')
                }
            }
        }
    }
}

document.getElementById('vooLoginBtn').onclick = function () {
    var username = document.getElementById('username').value;
    var password = document.getElementById('password').value;

    loginHandle(username, password);
};
if (document.getElementById('vooAltBtn')) {
    document.getElementById('vooAltBtn').onclick = function () {
        document.getElementById('loginForm').style.display = "none";
        document.getElementById('loginHeader').style.display = "none";
        document.getElementById('mainMenu').style.display = "none";
        document.getElementById('loginForm').style.display = "none";
        document.getElementById('cancelRecord').style.display = "none";

        document.getElementById('recordMenu').style.display = "block";
        document.getElementById('altSignUp').style.display = "inline-block";
    };
}

function getVideos(apiToken) {
    document.getElementById('mainMenu').style.display = "block";
    document.getElementById('loginForm').style.display = "none";
    document.getElementById('loginHeader').style.display = "none";
    const videosRequest = new XMLHttpRequest();
    videosRequest.open("GET", 'https://api.vooplayer.com/api/videos?vooKey=' + apiToken);
    videosRequest.send();
    videosRequest.onreadystatechange = function (e) {
        if (videosRequest.readyState === 4 && videosRequest.status === 200) {
            var videos = JSON.parse(videosRequest.responseText).videos;
            // @TODO FILIP: this is a paginated request, pagination needs to be handled
            var activeVideos = videos.data;
            var videoLength = activeVideos.length;
            var list = document.getElementById('videoList');

        // Clear all video item elements if existing (avoid duplicates)
        while (list.firstChild) {
            list.removeChild(list.firstChild);
        }
        list.insertAdjacentHTML('beforeend', '<div style="height: 15px;" class="video-container"></div>');
        // Add new video item elements to the list
        for (var i in activeVideos) {
          var video = activeVideos[i];
          var encodedID = btoa(video.id)
          var videoItem = '<div updated="'+ video.updated + '" name="'+ video.name + '" class="video-container">' +
             ' <div style="flex: 1 1 100%;">' +
                 ' <img style="background-image: url('+video.thumbnail+')" class="video-thumbnail" alt="">' +
                 ' <span style="display:inline;font-size:13px; height: 14px;">'+video.name+'</span>' +
             ' </div>' +
             ' <div style="flex: 0 0 80px;">' +
                 ' <button data-video="'+encodedID+'" id="edit'+encodedID+'" class="tooltip-container video-edit mdl-button mdl-js-button mdl-button--icon">' +
                     ' <i class="material-icons">edit</i>' +
                     ' <span class="tooltip">Edit</span>' +
                 ' </button>' +
                 ' <button data-video="'+encodedID+'" id="publish'+encodedID+'" class="tooltip-container video-publish mdl-button mdl-js-button mdl-button--icon">' +
                     ' <i class="material-icons">link</i>' +
                     ' <span class="tooltip">Publish Video</span>' +
                 ' </button>' +
             ' </div>' +
         ' </div>';

                list.insertAdjacentHTML('beforeend', videoItem);
            }
            setUpSearchListeners();
            setUpPublishListeners();
            orderVideosByUpdated('desc');
            document.getElementById('videoListLoader').style.display = "none";
        }
    }
}
