document.getElementById('recordBtn').onclick = function() {
  document.getElementById('recordMenu').style.display = "block";
  document.getElementById('mainMenu').style.display = "none";
  document.getElementById('loginForm').style.display = "none";
};

document.getElementById('cancelRecord').onclick = function() {
  document.getElementById('recordMenu').style.display = "none";
  document.getElementById('mainMenu').style.display = "block";
  document.getElementById('loginForm').style.display = "none";
};

document.getElementById('cancelPublish').onclick = function() {
  document.getElementById('publishMenu').style.display = "none";
  document.getElementById('mainMenu').style.display = "block";
  document.getElementById('loginForm').style.display = "none";
};


function setUpPublishListeners() {
  var classname = document.getElementsByClassName("video-publish");
  var callPublishMenu = function() {
      var videoID = this.getAttribute("data-video");

      chrome.storage.local.set({"publishVideoId": videoID}, function(){
        openPublishMenu(videoID);
        _gaq.push(['_trackEvent', 'Video List Item Interaction', 'Publish Code']);
      });
  };
  for (var i = 0; i < classname.length; i++) {
      classname[i].addEventListener('click', callPublishMenu, false);
  }

  var classname = document.getElementsByClassName("video-edit");
  var callEditVideo = function() {
    var videoLink = 'https://app.vooplayer.com/#/video/' + this.getAttribute("data-video");
    window.open(videoLink, '_blank');
  };
  for (var i = 0; i < classname.length; i++) {
      classname[i].addEventListener('click', callEditVideo, false);
  }

}
function setUpSearchListeners() {
    var searchVideo = document.getElementById('search-videos');
    var inputChangeHandle = function () {
        filterVideoListByName(this.value);
    };

    searchVideo.style.display = 'block';

    // Reset event listener for input change
    searchVideo.removeEventListener('input', inputChangeHandle)
    //searchVideo.addEventListener('change', inputChangeHandle);
    searchVideo.addEventListener('input', inputChangeHandle);
}
function filterVideoListByName(input) {
    var videoItems = document.getElementsByClassName('video-container');

    for (var i in videoItems) {
        var videoElement = videoItems[i];

        if (videoElement && videoElement.getAttribute) {
            input = input.toLowerCase();
            var name = videoElement.getAttribute("name").toLowerCase();

            if (!input) {
                videoElement.style.position = 'static';
                videoElement.style.left = 'initial';
                videoElement.style.top = 'initial';
            }
            else {
                if (!name || name.indexOf(input) < 0) {
                    videoElement.style.position = 'absolute';
                    videoElement.style.left = '9999px';
                    videoElement.style.top = '9999px';
                }
                else {
                    videoElement.style.position = 'static';
                    videoElement.style.left = 'initial';
                    videoElement.style.top = 'initial';
                }
            }
        }
    }
}

var runtimePort = chrome.runtime.connect({
    name: location.href.replace(/\/|:|#|\?|\$|\^|%|\.|`|~|!|\+|@|\[|\||]|\|*. /g, '').split('\n').join('').split('\r').join('')
});

runtimePort.onMessage.addListener(function(message) {
    if (!message || !message.messageFromContentScript1234) {
        return;
    }
});

var isRecording = false;
var recordSwitches = {};

chrome.storage.sync.get('isRecording', function(obj) {
    isRecording = obj.isRecording === 'true';

    // auto-stop-recording
    if (isRecording === true) {

        chrome.tabs.query({}, function(tabs) {
        var tabIds = [];
        var url = 'chrome-extension://' + chrome.runtime.id + '/video.html';
        for (var i = tabs.length - 1; i >= 0; i--) {
            if (tabs[i].url === url) {
                tabIds.push(tabs[i].id);
                chrome.tabs.update(tabs[i].id, {
                    active: true,
                    url: url
                });
                break;
            }
        }
        if (tabIds.length) {
            chrome.tabs.remove(tabIds);
        }
    });
    }
});

document.getElementById('altSignUp').onclick = function(e) {
    e.preventDefault();

    chrome.storage.local.set({
        "altSingUp": 'true'
    }, function () {
        runtimePort.postMessage({
            messageFromContentScript1234: true,
            openSignUp: true
        });
    });
};
document.getElementById('recordSettings').onclick = function(e) {
    e.preventDefault();

    window.open('options.html', '_blank')
};

document.getElementById('screen-switch').onclick = function() {
    switchControlHandle('screen');

    if (recordSwitches.camera && recordSwitches.screen) {
        toggleCameraPreviewSwitch(true);
        switchControlHandle('camera-box', 'off');
    } else {
        switchControlHandle('camera-box', 'on');
        switchControlHandle('camera-window', 'on');
        toggleCameraPreviewSwitch(false);
    }
};
document.getElementById('camera-switch').onclick = function() {
    switchControlHandle('camera');

    if (recordSwitches.camera && recordSwitches.screen) {
        toggleCameraPreviewSwitch(true);
        switchControlHandle('camera-box', 'off');
    } else {
      switchControlHandle('camera-box', 'on');
      switchControlHandle('camera-window', 'on');
      toggleCameraPreviewSwitch(false);
    }
};
document.getElementById('mic-switch').onclick = function() {
    switchControlHandle('mic');
};
document.getElementById('startRecordingBtn').onclick = function () {
    _gaq.push(['_trackEvent', 'Extension Started Recording', 'Successful']);
    _gaq.push(['_trackEvent', 'Extension Recording Config', generateRecordTypeLabel()]);

    runtimePort.postMessage({
        messageFromContentScript1234: true,
        startRecording: true
    });
    window.close();
};
if (document.getElementById('order-videos-updated')) {
    document.getElementById('order-videos-updated').onclick = function() {
        if (document.getElementById('order-videos-updated').getAttribute('value') === 'desc') {
            document.getElementById('order-videos-updated').setAttribute('value', 'asc');
            orderVideosByUpdated('asc');
        } else {
            document.getElementById('order-videos-updated').setAttribute('value', 'desc');
            orderVideosByUpdated('desc');
        }
    };
}

function orderVideosByUpdated(order) {
   function compare(a,b) {
      var aDate = new Date(a);
      var bDate = new Date(b);

      if (aDate < bDate) {
        return -1;
      }
      if (aDate > bDate) {
        return 1;
      }

      return 0;
    }

   setTimeout(function() {
       var wrapper = document.getElementById('videoList');
       var updatedMapping = {};
       var sortedUpdatedKeys = [];

       // Remove all children items and map them.
       while (wrapper.firstElementChild) {
           var videoItem = wrapper.firstElementChild;
           var updated = videoItem.getAttribute('updated');

            if (updated) {
                updatedMapping[updated] = videoItem;

                sortedUpdatedKeys.push(updated);
            }

            wrapper.removeChild(wrapper.firstElementChild);
       }

           // Sort updated keys mapping.
           sortedUpdatedKeys.sort(compare);

           if (order === 'desc') {
              sortedUpdatedKeys = sortedUpdatedKeys.reverse();
           }

      console.log('updatedMapping', updatedMapping);
      console.log('sortedUpdatedKeys after sorting', sortedUpdatedKeys);
           // Append children in order.
           for (var i = 0; i < sortedUpdatedKeys.length; i++) {
             var key = sortedUpdatedKeys[i];
             var child = updatedMapping[key];

             wrapper.appendChild(child);
           }
   }, 100);
}
function toggleCameraPreviewSwitch(show) {
    var wrappers = document.getElementsByClassName('sub');

    for (var i = 0; i < wrappers.length; i++) {
        wrappers[i].style.display = show ? 'flex' : 'none';
    }
}
function generateRecordTypeLabel() {
    var label = 'Recording ';

    if (recordSwitches.camera) {
        label += 'Camera';

        if (recordSwitches.screen) {
            label += ' + Screen';
        }
        if (recordSwitches.mic) {
            label += ' + Microphone';
        }
    } else if (recordSwitches.screen) {
        label += 'Screen';

        if (recordSwitches.mic) {
            label += ' + Microphone';
        }
    } else if (recordSwitches.mic) {
        label += 'Microphone';
    }

    label += '.';

    return label;
}
function switchControlHandle(control, oldValue) {
    var controlElement = document.getElementById(control + '-switch');

    if (!controlElement) return;

    var switchValue = oldValue ? oldValue : controlElement.getAttribute('value');

    if (switchValue === "on") {
       switchValue = false;
       controlElement.setAttribute('value', 'off');
    } else {
       switchValue = true;
       controlElement.setAttribute('value', 'on');
    }

    recordSwitches[control] = switchValue;
    runtimePort.postMessage({
        messageFromContentScript1234: true,
        controlSwitch: {
            name: control,
            value: switchValue
        }
    });
}

//console.log('Reset switchers each time dropdown is loaded!');

runtimePort.postMessage({
    resetControls: true
});

(function() {
    if (document.getElementById('order-videos-updated') && !document.getElementById('order-videos-updated').getAttribute('value')) {
       setTimeout(function() {
            //orderVideosByUpdated('desc');
            document.getElementById('order-videos-updated').setAttribute('value', 'asc');
            document.getElementById('order-videos-updated').click();
       }, 1300);
    }
})();