var video = document.querySelector('video');
var fname = document.querySelector('#file-name');
var fsize = document.querySelector('#file-size');
var fduration = document.querySelector('#file-duration');
var fresolutions = document.querySelector('#file-resolutions');
var header = document.querySelector('header');

var browserCache = document.querySelector('#browser-cache');
var tokenFetched = false;
var apiKeyFetched = false;

function getAPIKey(user) {
    const authRequest = new XMLHttpRequest();
    const token = user.token;
    const userId = user.id;

    authRequest.open("GET", 'https://api.vooplayer.com/user/generateIntegrationsApiKey?Token=' + token + '&userID=' + userId);
    authRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    authRequest.onreadystatechange = function () {
        if (authRequest && authRequest.responseText && !apiKeyFetched) {
            apiKeyFetched = true;
            var apiKey = JSON.parse(authRequest.responseText);

            chrome.storage.local.set({
                "vooAPIKey": apiKey,
                'subdomain': user.subdomain,
                'betaOptimization': 'true'
            }, function () {
            });

            //alert('Sign Up completed successfully!');
            handleUploadPage();
            toggleLoader();
            setTimeout(function () {
                chrome.storage.local.set({
                    "altSingUp": 'false'
                }, function () {});
            }, 2000);
        }
    };

    authRequest.send();
}
function loginHandle(username, password) {
    const authRequest = new XMLHttpRequest();

    authRequest.open("POST", 'https://api.vooplayer.com/login');
    authRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    authRequest.send('username=' + username + '&password=' + password);
    authRequest.onreadystatechange = function(e) {
        if (authRequest && authRequest.responseText) {
            var authData = JSON.parse(authRequest.responseText);
            var user = authData[0];

            if (user.integrationsApiKey) {
                _gaq.push(['_trackEvent', 'Extension Login', 'Successful']);
                chrome.storage.local.set({
                    "vooAPIKey": user.integrationsApiKey,
                    'subdomain': user.subdomain,
                    'betaOptimization': 'true'
                }, function () {
                });
            } else {
                if (!user.token && !tokenFetched) {
                    loginHandle(username, password);

                    return;
                }
                if (user.id && !tokenFetched) {
                    tokenFetched = true;
                    // Create API token.
                    getAPIKey(user);
                }

            }
        }
    }
}

chrome.storage.local.get(["altSingUp"], function(items){
    var isAltSignUp = items.altSingUp === 'true';

    if (isAltSignUp) {
        handleSignUpPage(isAltSignUp);

        return;
    }

    DiskStorage.GetLastSelectedFile(recentFile, function(file) {
        if (!file) {
            onGettingFile(file);
            return;
        }

        DiskStorage.GetFilesList(function(list) {
            if (!recentFile) {
                onGettingFile(file, list[0]);
                return;
            }

            var found;
            list.forEach(function(item) {
                if (typeof item === 'string') {
                    if (item === recentFile) {
                        found = {
                            name: item,
                            display: item,
                            php: '',
                            youtube: ''
                        };
                    }
                } else if (item.name === recentFile) {
                    found = item;
                }
            });

            if (!found) {
                onGettingFile(file, list[0]);
                return;
            }

            onGettingFile(file, found);

            if (!items.vooAPIKey) {
                handleSignUpPage();
            } else {
                setTimeout(function () {
                    chrome.storage.local.set({
                        "altSingUp": 'false'
                    }, function () {});
                }, 2000);
            }
        });
    });

});
function toggleLoader(show) {
    var bodyElement = document.getElementsByTagName('body')[0];

    if (show) {
        bodyElement.style.opacity = '0.2';
        bodyElement.style.pointerEvents = 'none';
    } else {
        bodyElement.style.opacity = '1';
        bodyElement.style.pointerEvents = 'all';
    }
}
function handleSignUpPage(isAltSignUp) {
    document.querySelector('body').style.opacity = '0';
    document.getElementById('uploadInfo').style.display = 'none';
    if (isAltSignUp) {
        document.getElementById('video-preview').style.display = 'none';
    }

    document.getElementById('signUp').onclick = function() {
        var username = document.getElementById('username').value;
        var password = document.getElementById('password').value;
        var apiURL = 'https://api.vooplayer.com/user/demo';
        var newUserData = '&productID=33&processorName=force&price=0&transID=demo&qty=1';
        var secureToken = '18763095f637119d787e88106a89cb64';
        var params = 'firstName=' + encodeURIComponent(username) +
            '&lastName=' + encodeURIComponent(username) +
            '&username=' + encodeURIComponent(username) +
            '&password=' + encodeURIComponent(password) +
            '&subdomain=' + encodeURIComponent(username) +
            '&App-Token=' + secureToken + newUserData;

        toggleLoader(true);
        postRequest(apiURL, params, function () {
            loginHandle(username, password);
        });
    };

    setTimeout(function () {
        document.querySelector('body').style.opacity = '1';
        document.getElementById('signUpInfo').style.display = 'block';

        if (isAltSignUp) {
            document.getElementById('signup-preview').style.display = 'block';
        }

    }, 500);
}
function handleUploadPage() {
    document.getElementById('uploadInfo').style.display = 'block';
    document.getElementById('video-preview').style.display = 'block';
    document.getElementById('signUpInfo').style.display = 'none';
    document.getElementById('signup-preview').style.display = 'none';
}
function postRequest (url, data, callback) {
    var xhr = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP");

    xhr.open('POST', url, true);

    xhr.setRequestHeader("Accept", "application/json, text/plain, */*");
    xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
    xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
    xhr.onreadystatechange = function() {
        if (xhr.readyState > 3 && xhr.status > 199 && xhr.status < 299) {
            callback({ data: xhr.responseText });
        }
        if (xhr.readyState > 3 && xhr.status > 399) {
            callback({
                error: true,
                message: xhr.responseText
            })
        }
    };
    xhr.send(data);

    return xhr;
}
function setVideoWidth() {
    video.style.cursor = 'pointer';
    // video.style.marginTop = header.clientHeight;
    // video.style.height = innerHeight - header.clientHeight;
}

window.onresize = setVideoWidth;

var file;

function onGettingFile(f, item) {
    file = f;

    if (!file) {
        if (item && item.name) {
            header.querySelector('p').innerHTML = item.display + ' has no video data.';
            header.querySelector('span').innerHTML = '';
        } else {
            header.querySelector('p').innerHTML = 'You did NOT record anything yet.';
            header.querySelector('span').innerHTML = '';
        }
        return;
    }

    file.item = item;

    if(!file.url || file.url.toString().toLowerCase().indexOf('youtube') !== -1) {
        file.url = URL.createObjectURL(file);
    }

    (function() {
        // this function calculates the duration
        var hidden = document.createElement('video');
        var url = file.url;
        hidden.currentTime = 9999999999;
        hidden.onloadedmetadata = function() {
            if(url !== file.url) return;

            fresolutions.innerHTML = hidden.clientWidth + 'x' + hidden.clientHeight;

            if(hidden.duration === Infinity) {
                setTimeout(hidden.onloadedmetadata, 1000);
                return;
            }
            fduration.innerHTML = formatSecondsAsTime(hidden.duration);
            hidden.parentNode.removeChild(hidden);
        };
        hidden.style = 'position: absolute; top: -99999999999; left: -99999999999; opacity: 0;';
        (document.body || document.documentElement).appendChild(hidden);
        hidden.muted = true;
        hidden.src = file.url;
        hidden.play();
    })();

    video.onloadedmetadata = function() {
        // video.onloadedmetadata = null;

        // seek back to the beginning
        // video.currentTime = 0;
    };

    video.src = file.url;
    video.currentTime = 9999999999;

    if(file.name && (file.name.indexOf('.mp3') !== -1 || file.name.indexOf('.wav') !== -1 || file.name.indexOf('.ogg') !== -1)) {
        video.style.background = 'url(images/no-video.png) no-repeat center center';
        video.currentTime = 0;
    }
    else {
        video.style.background = '';
    }

    fname.innerHTML = item.display;
    fsize.innerHTML = bytesToSize(file.size);

    setVideoWidth();
    video.onclick = function() {
        video.onclick = null;
        video.style.cursor = '';
        video.play();
    };

    var html = 'This file is in your browser cache. Upload it to vooPlayer.';

    // just go to the editor ...

    chrome.storage.local.get(["recentUploadResponse"], function(items){
      if(items.recentUploadResponse){
        var recentUploadResponse = items.recentUploadResponse;
        var id = recentUploadResponse.split("/").pop();
        var conversionNeeded = file.type !== 'video/mp4' ? '?source=plugin' : '';
        var editURL = 'http://app.vooplayer.com/#/video/'+ id + conversionNeeded;
        chrome.storage.local.remove(["recentUploadResponse"],function(){});
        window.open(editURL,"_self");
      }
    });

    // meh...

    if (item.php && item.youtube) {
    } else if (item.php) {
        html = 'Your file has been uploaded to vooPlayer. Go to your  <a href="https://app.vooplayer.com" target="_blank">dashboard.</a>';
    } else if (item.youtube) {
    }
    browserCache.innerHTML = html;
    if (browserCache.querySelector('.cross-icon')) {
        browserCache.querySelector('.cross-icon').onclick = function() {
            if (window.confirm('Do you want to delete this video from server?')) {
                deleteFromPHPServer(item.name, function(response) {
                    DiskStorage.UpdateFileInfo(file.name, {
                        php: ''
                    }, function() {
                        if (response === 'deleted') {
                            location.reload();
                        } else {
                            alert(response);
                        }
                    });
                });
            }
        };
    }

    localStorage.setItem('selected-file', file.name);
}

var recentFile = localStorage.getItem('selected-file');

var btnUploadDropDown = document.querySelector('#btn-upload-dropdown');
document.querySelector('#btn-php-upload').onclick = function(e) {
    e.stopPropagation();

    if (!file) {
        alert('You have no recordings.');
        return;
    }

    if (btnUploadDropDown.className === 'visible') {
        btnUploadDropDown.className = '';
    } else {
        btnUploadDropDown.className = 'visible';
    }
};

var btnRecordingsListDropDown = document.querySelector('#btn-recordings-list-dropdown');
document.querySelector('#btn-recordings-list').onclick = function(e) {
    e.stopPropagation();

    if (btnRecordingsListDropDown.className === 'visible') {
        btnRecordingsListDropDown.className = '';
        btnRecordingsListDropDown.innerHTML = '';
    } else {
        btnRecordingsListDropDown.className = 'visible';

        btnRecordingsListDropDown.innerHTML = '';
        DiskStorage.GetFilesList(function(list) {
            if (!list.length) {
                btnRecordingsListDropDown.className = '';
                alert('You have no recordings.');
                return;
            }

            list.forEach(function(item) {
                var div = document.createElement('div');
                div.innerHTML = '<img src="images/cross-icon.png" class="cross-icon"><img src="images/edit-icon.png" class="edit-icon">' + item.display;
                btnRecordingsListDropDown.appendChild(div);

                div.querySelector('.cross-icon').onclick = function(e) {
                    e.preventDefault();
                    e.stopPropagation();

                    if (!window.confirm('Are you sure you want to permanently delete the selected recording?')) {
                        return;
                    }

                    function afterDelete() {
                        if (div.previousSibling) {
                            div.previousSibling.click();
                        } else if (div.nextSibling) {
                            div.nextSibling.click();
                        } else {
                            location.reload();
                        }

                        div.parentNode.removeChild(div);
                    }

                    DiskStorage.RemoveFile(item.name, function() {
                        if(!item.php || !item.php.length) {
                            afterDelete();
                            return;
                        }

                        deleteFromPHPServer(item.name, afterDelete);
                    });
                };

                div.querySelector('.edit-icon').onclick = function(e) {
                    e.preventDefault();
                    e.stopPropagation();

                    var newFileName = prompt('Please enter new file name', item.display) || item.display;

                    DiskStorage.UpdateFileInfo(item.name, {
                        display: newFileName
                    }, function() {
                        item.display = newFileName;

                        onGettingFile(file, item);
                        document.body.onclick();
                    });
                };

                div.onclick = function(e) {
                    e.preventDefault();
                    e.stopPropagation();

                    DiskStorage.Fetch(item.name, function(file) {
                        onGettingFile(file, item);
                    });

                    document.body.onclick();
                };

                if (file && file.item && file.item.name === item.name) {
                    div.className = 'btn-upload-dropdown-selected';
                }
            });
        });
    }
};

document.body.onclick = function() {
    if (btnUploadDropDown.className === 'visible') {
        btnUploadDropDown.className = '';
    }

    if (btnRecordingsListDropDown.className === 'visible') {
        btnRecordingsListDropDown.className = '';
    }
};

function formatSecondsAsTime(secs) {
    var hr = Math.floor(secs / 3600);
    var min = Math.floor((secs - (hr * 3600)) / 60);
    var sec = Math.floor(secs - (hr * 3600) - (min * 60));

    if (min < 10) {
        min = "0" + min;
    }
    if (sec < 10) {
        sec = "0" + sec;
    }

    if (hr <= 0) {
        return min + ':' + sec;
    }

    return hr + ':' + min + ':' + sec;
}
