var bkg = chrome.extension.getBackgroundPage();
// bkg.console.log('hello world');

function generateCodes(property, callback) {
    var publishOptions = {};

    chrome.storage.local.get('publishVideoId', function(videoIdData) {
        var videoId = videoIdData && videoIdData.publishVideoId ? videoIdData.publishVideoId : false;

        if (!videoId) {
            return;
        }
        chrome.storage.local.get(property, function(data) {
            publishOptions[property] = false;
            var scriptString = '<script src="https://' + customSubdomain + '.cdn.vooplayer.com/assets/vooplayer.js"></script>';
            var iframeString = '<iframe allow="autoplay" class="video-player-container vooplayer" data-playerId="' +
                                videoId + '" allowtransparency="true" style="max-width:100%" name="vooplayerframe"' +
                                ' allowfullscreen="true" src="" watch-type="" url-params="" frameborder="0" scrolling="no"></iframe>';


            if (data && data[property]) {
                publishOptions[property] = data[property] === 'true' ? false : true;
            }
            switch (property) {
                case 'betaOptimization':
                    publishOptions.fallbackCode = publishOptions[property] ? false : publishOptions.fallbackCode;
                    break;
                case 'fallbackCode':
                    publishOptions.betaOptimization = publishOptions[property] ? false : publishOptions.betaOptimization;
                    break;
            }

            if (!publishOptions.betaOptimization) {
                iframeString = '<iframe allow="autoplay" class="video-player-container vooplayer" data-playerId="' +
                                                videoId + '" allowtransparency="true" style="max-width:100%" name="vooplayerframe"' +
                                                ' allowfullscreen="true" src="' +
                                                'https://' + customSubdomain + '.cdn.vooplayer.com/publish/' + videoId +
                                                '" watch-type="" url-params="" frameborder="0" scrolling="no"></iframe>';
            }
            if (publishOptions.fallbackCode) {
                iframeString = '<div style="position:relative; width:1px; min-width:100%; padding-bottom:56.25%">' +
                               '<iframe allow="autoplay" class="vooplayer" allowtransparency="true" ' +
                               'style="width:1px; min-width:100%; height: 100%; position:absolute" ' +
                               'allowfullscreen="true" src="https://' + customSubdomain + '.cdn.vooplayer.com/publish/' +
                               videoId + '?fallback=true" frameborder="0" scrolling="no"></iframe></div>';
            }

            document.getElementById('embedCode').value = scriptString + iframeString;
            callback(publishOptions[property]);

            for (var key in publishOptions) {
                var data = {};

                data[key] = String(publishOptions[key]);
                chrome.storage.local.set(data, function(){});
            }
        });

    });
}

function openPublishMenu(encodedID) {
  document.getElementById('publishMenu').style.display = "block";
  document.getElementById('mainMenu').style.display = "none";
  document.getElementById('loginForm').style.display = "none";

  chrome.storage.local.get('subdomain', function(data) {
    if (data && data.subdomain) {
      console.log('User custom subdomain ... ',data.subdomain);
      customSubdomain = data.subdomain;

        document.getElementById('publishLink').value = customSubdomain !== '46585' ? 'https://' + customSubdomain + '.cdn.vooplayer.com/publish/' + encodedID : 'https://app.vooplayer.com/publish/' + encodedID;
        document.getElementById('embedCode').value = '<script src="https://' + customSubdomain + '.cdn.vooplayer.com/assets/vooplayer.js"></script><iframe allow="autoplay" class="video-player-container vooplayer" data-playerId="'+encodedID+'" allowtransparency="true" style="max-width:100%" name="vooplayerframe" allowfullscreen="true" src="" watch-type="" url-params="" frameborder="0" scrolling="no"> </iframe>';
    }
  });
}

var customSubdomain = '46585';
var snackbarContainer = document.querySelector('#demo-snackbar-example');

document.getElementById('copyLink').onclick = function(event) {
  var copyText = document.getElementById("publishLink");
  copyText.select();
  document.execCommand("copy");
  var data = {
    message: 'Share Link copied to Clipboard.',
    timeout: 2000
  };
  snackbarContainer.MaterialSnackbar.showSnackbar(data);
};
document.getElementById('copyCode').onclick = function() {
  var copyText = document.getElementById("embedCode");
  copyText.select();
  document.execCommand("copy");
  var data = {
    message: 'Embed Code copied to Clipboard.',
    timeout: 2000
  };
  snackbarContainer.MaterialSnackbar.showSnackbar(data);
  _gaq.push(['_trackEvent', 'Video List Item Interaction', 'Copied Code']);
};

document.getElementById('publish-beta-switch').onclick = function() {
    generateCodes('betaOptimization', function(betaOn) {
        if (betaOn) {
            switchPublishHandle('publish-beta', 'off');
            switchPublishHandle('publish-fallback', 'on');
        } else {
            switchPublishHandle('publish-beta', 'on');
        }
    });
};
document.getElementById('publish-fallback-switch').onclick = function() {
    generateCodes('fallbackCode', function(fallbackOn) {
        if (fallbackOn) {
            switchPublishHandle('publish-beta', 'on');
            switchPublishHandle('publish-fallback', 'off');
        } else {
            switchPublishHandle('publish-fallback', 'on');
        }
    });
};

function switchPublishHandle(control, oldValue) {
    var controlElement = document.getElementById(control + '-switch');

    if (!controlElement) return;

    var switchValue = oldValue ? oldValue : controlElement.getAttribute('value');

    if (switchValue === "on") {
       controlElement.setAttribute('value', 'off');
    } else {
       controlElement.setAttribute('value', 'on');
    }
}